/* Allocation macros and functions */

#ifndef _memory_
#define _memory_

#include "mlvalues.h"

/*extern value *c_roots_head;*/

#ifdef ANSI

extern char *stat_alloc (size_t);	        /* Size in bytes. */
extern void stat_free (char *);

/*extern void init_memory (asize_t, asize_t);
extern value raw_alloc_shr (mlsize_t, tag_t);
extern value alloc_shr (mlsize_t, tag_t);
extern void modify (value *, value);
extern void initialize (value *, value);
extern char * stat_resize (char *, asize_t);     / * Size in bytes. * /
*/
#else

extern char *stat_alloc ();		/* Size in bytes. */
extern void stat_free ();

/*void init_memory ();
value raw_alloc_shr ();
value alloc_shr ();
void modify ();
void initialize ();
char * stat_resize ();		/ * Size in bytes. * /
*/
#endif /* ANSI */

/*#define Alloc_small(result, wosize, tag) {				      \
  char *_res_ = young_ptr;						      \
  young_ptr += Bhsize_wosize (wosize);					      \
  if (young_ptr > young_end){						      \
    Setup_for_gc;							      \
    minor_collection ();						      \
    Restore_after_gc;							      \
    _res_ = young_ptr;							      \
    young_ptr += Bhsize_wosize (wosize);				      \
  }									      \
  Hd_hp (_res_) = Make_header ((wosize), (tag), Black);			      \
  (result) = Val_hp (_res_);						      \
}*/

/* You must use [Modify] to change a field of an existing shared block,
   unless you are sure the value being overwritten is not a shared block and
   the value being written is not a young block. */
/* [Modify] never calls the GC. */
/*#define Modify(fp, val) {						      \
  value _old_ = *(fp);							      \
  *(fp) = (val);							      \
  if (Is_in_heap (fp)){							      \
    if (gc_phase == Phase_mark) darken (_old_);				      \
    if (Is_block (val) && Is_young (val)				      \
	&& ! (Is_block (_old_) && Is_young (_old_))){			      \
      *ref_table_ptr++ = (fp);						      \
      if (ref_table_ptr >= ref_table_end){				      \
        Assert (ref_table_ptr == ref_table_end);			      \
	realloc_ref_table ();						      \
      }									      \
    }									      \
  }									      \
}*/

#define Push_roots(name, size)                                                \
   value name [size];

#define Pop_roots() { }

#endif /* _memory_ */
